{#
/**
 * The main menu navigation within a site.
 *
 * menu_item - An array of link objects (props from https://api.drupal.org/api/drupal/core%21themes%21stable9%21templates%21navigation%21menu.html.twig/9)
 *   - attributes: HTML attributes for the menu item.
 *   - below: The menu item child items.
 *   - title: The menu link title.
 *   - url: The menu link url, instance of \Drupal\Core\Url
 *   - localized_options: Menu link localized options.
 *   - is_expanded: TRUE if the link has visible children within the current
 *     menu tree.
 *   - is_collapsed: TRUE if the link has children within the current menu tree
 *     that are not currently visible.
 *   - in_active_trail: TRUE if the link is in the active trail.
 */
#}

{% from '@cambridge_tailwind/components/link/link.twig' import linkClasses %}
{% set menuLinkClasses = linkClasses(true, false) | spaceless | split(" ") | merge(["flex", "flex-row", "items-center", "self-center", "gap-4", "leading-7", "p-8"]) %}

<div id="menu-wrapper">
  <div id="menu-overlay" class="hidden fixed inset-0 bg-black bg-opacity-50 z-20"></div>
  {# Get's wrapped by a `nav` by Drupal, so we don't need to add one here #}
  <div class="bg-blue-700 z-30 relative" id="menu-bar">
    <div class="2xl:container mx-auto px-16 md:px-24 lg:px-32" id="menu-items-wrapper">
      {# Alternative mobile nav #}
      {% include "@cambridge_tailwind/components/menu/mobile-menu.twig" with { menu_items: menu_items } %}
      {# Above mobile-size nav #}
      <ul
        class="flex justify-start py-12 relative flex-wrap mx-[-8px]"
        role="menubar"
        aria-label=""
        id="menu-items"
      >
        {% set count = 0 %}
        {% for item in menu_items %}
          {% set count = count + 1 %}
          {% set linkAttributes = create_attribute().addClass(menuLinkClasses).addClass(["mr-8", "text-nowrap", "sm:mr-12"]) %}
          {% if item.in_active_trail %}
            {% set linkAttributes = linkAttributes.removeClass("no-underline").addClass(["font-semibold", "underline", "decoration-blue-200", "text-blue-200"]) %}
          {% endif %}
          <li role="none" id="menu-items-{{ count }}">
            {% include "@cambridge_tailwind/components/menu/main-menu-link.twig" with { item: item, linkAttributes: linkAttributes, count: count } %}
            {% if item.below %}
              {% include "@cambridge_tailwind/components/menu/open-section-panel.twig" with { section: item, count: count }  %}
            {% endif %}
          </li>
        {% endfor %}
        {# Create the links for the more dropdown #}
        {# These get shown as required #}
        <li id="nav-more-container" aria-hidden="true" class="sm:relative hidden" role="none">
          {% set linkAttributes = create_attribute().addClass(menuLinkClasses) %}
          <button id="nav-more-button" {{linkAttributes}} aria-haspopup="true" type="button" aria-controls="nav-more-menu" aria-expanded="false" role="menuitem">
            More
            {% include "@cambridge_tailwind/components/menu/images/dots-three-vertical.svg.twig" %}
          </button>
          <ul class="bg-blue-700 z-30 absolute left-8 sm:left-auto mt-[-12px] sm:mt-0 right-8 sm:right-0 top-[100%] min-w-[200px] hidden shadow-md rounded-4 border border-solid border-divider-contrast-subtle" id="nav-more-menu" aria-hidden="true">
            {% set count = 0 %}
            {% for item in menu_items %}
              {% set count = count + 1 %}
              <li role="none" class="hidden" aria-hidden="true" id="more-menu-items-{{ count }}">
                {% set linkAttributes = create_attribute().addClass(menuLinkClasses).removeClass(["p-8"]).addClass("border-solid border-divider-contrast-subtle [&:not(:last-child)]:border-b sm:text-nowrap xs:text-wrap px-16 py-12") %}
                {% if item.in_active_trail %}
                  {% set linkAttributes = linkAttributes.removeClass("no-underline").addClass(["font-semibold", "underline", "decoration-blue-200", "text-blue-200"]) %}
                {% endif %}
                {% include "@cambridge_tailwind/components/menu/main-menu-link.twig" with { item: item, linkAttributes: linkAttributes, count: count } %}
              </li>
            {% endfor %}
          </ul>
        </li>
      </ul>
    </div>
  </div>
</div>
